// main.js

//bild the calendar for the selecteed month
var CurrentMonth = new Date(2005,1,1);
var Today = new Date();
var monthNames = new Array("Jan", "Feb", "Mar", "Apr", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec");


//Is Date Equal
function IsDateEqual(Date1, Date2){
  return ((Date1.getYear() == Date2.getYear()) && (Date1.getMonth() == Date2.getMonth()) && (Date1.getDate() == Date2.getDate()));
}

//Build the calendar
function BuildCalendarForDate(year, month){
  //Days in the month
  var days = new Array(31, ((year % 4 == 0 && year % 100 != 0) || year % 400 == 0 ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
  //Name of the Months
  //Date we are building the caledar
  CurrentMonth.setYear(year);
  CurrentMonth.setMonth(month);
  var todayhl = this.layers('TodayHL');
  var sday = CurrentMonth.getDay();
  var dayofmonth = 1;
  var daylayer;
  var ChkToday = new Date(year,month,1);
  this.LockAllUpdates();
  todayhl.visible = false;

  for (var cweek=0; cweek<6 ; cweek++)  //Loop each week  0-4on the calendar
  {
    for (var cday=0; ( ((cday<7) && (cweek<5)) || ((cday<2) && (cweek ==5)) ) ; cday++)
    {
      daylayer = this.layers(cweek+'-'+cday);
      if ((cday < sday) || (dayofmonth>days[month]) ) //Black everything till the first day of the month
      {
        daylayer.text = '';
        daylayer.data = '';
      }
      else
      {
        if (sday >= 0)
          sday = -1; //reset it to -1 so that we no longer blank anything
        daylayer.LockUpdates();
        daylayer.text = dayofmonth;
        daylayer.data = year+'_'+(month+1)+'_'+dayofmonth;
        if (this.XMLS(0).GetValue('[//TASK[@DATE="'+daylayer.data+'"]]') != '')
          daylayer.fontcolor = 'clYellow';
        else
          daylayer.fontcolor = 'clWhite';
        //See if the date draw is TODAY
        ChkToday.setDate(dayofmonth);
        if (IsDateEqual(ChkToday,Today))
        {
          todayhl.LockUpdates();
          todayhl.X = daylayer.X+6;
          todayhl.Y = daylayer.Y-1;
          todayhl.Visible = true;
          todayhl.ReDraw();
          daylayer.fontcolor = '#8f4417';
        }
        daylayer.ReDraw();
        dayofmonth++;
      }
    }
  }
  this.Refresh();
}

//Create
function CreateInitialTaskFile(){
  var tpath = this.parameters('TASKPATH');
  if (tpath.Value == '') //create inital path
  {
    var  TaskDir = this.IO.GetUserDocumentPath()+'\\My Tasks';
    this.IO.CreateDirectory(TaskDir);
    tpath.Value = TaskDir+'\\'+this.IO.GenerateUniqueName()+'.XML';
    this.XMLS(0).ClearXML();
    this.XMLS(0).SaveXML();
  }
}

//Initial startup
function Init(){
  CreateInitialTaskFile();
  this.XMLS(0).ForceGetData();
  BuildCalendarForDate(Today.getYear(),Today.getMonth());
  DrawDate(Today);
}

//Draw the current date
function DrawDate(NewDate){
  var lyDate = this.layers('Date');
  var lyYear = this.layers('Year');
  var lyMonth = this.layers('Month');
  this.LockAllUpdates();
  lyDate.Text = NewDate.getDate();
  lyYear.Text = NewDate.getYear();
  lyMonth.Text = monthNames[NewDate.getMonth()];
  this.Refresh();
}

//Move the month
function GotoMonth(Pos){
  if (Pos==0)  //Today
  {
    BuildCalendarForDate(Today.getYear(),Today.getMonth());
    DrawDate(Today);
  }
  else
  if (Pos==1) //Next month
  {
    var NewDate = new Date(CurrentMonth);
    var NewMonth = CurrentMonth.getMonth()+1;
    NewDate.setMonth(NewMonth);
    if ((NewDate.getYear() == Today.getYear()) && (NewDate.getMonth() == Today.getMonth()))
    {
      GotoMonth(0);
    }
    else
    {
      BuildCalendarForDate(NewDate.getYear(),NewDate.getMonth());
      DrawDate(CurrentMonth);
    }
  }
  else
  {
    var NewDate = CurrentMonth;
    var NewMonth = CurrentMonth.getMonth()-1;
    NewDate.setMonth(NewMonth);
    if ((NewDate.getYear() == Today.getYear()) && (NewDate.getMonth() == Today.getMonth()))
    {
      GotoMonth(0);
    }
    else
    {
      BuildCalendarForDate(NewDate.getYear(),NewDate.getMonth());
      DrawDate(CurrentMonth);
    }
  }
}

//Check the date if it has changed
function CheckDate(){
  var chkdate = new Date();
  if (!IsDateEqual(Today,chkdate))
  {
    Today = chkdate;
    Init();
  }
}

//Hide / close the event page
function CloseEvent(){
  var event = this.layers('EventList');
  var closebtn = this.layers('CloseBtn');
  var editctrl = this.controls('EventEdit');
  this.LockAllUpdates();
  event.Visible = false;
  closebtn.Visible = false;
  editctrl.Visible = false;
   //Save Data
  this.XMLS(0).WriteAttribValue('/root/TASK[@DATE="'+event.data+'"]','DATE',event.data);
  this.XMLS(0).WriteTextValue('/root/TASK[@DATE="'+event.data+'"]',editctrl.value);
  this.XMLS(0).SaveXML();
  BuildCalendarForDate(Today.getYear(),Today.getMonth());
  this.ReFresh();
}

//Show teh events for the selected date!
function ShowEvent(){
  var lyactive = this.GetActiveLayer();
  if (lyactive.data != '')
  {
    this.LockAllUpdates();
    var event = this.layers('EventList');
    var closebtn = this.layers('CloseBtn');
    var editctrl = this.controls('EventEdit');
    //Show the text
    editctrl.Value = this.XMLS(0).GetValue('[//TASK[@DATE="'+lyactive.data+'"]]');
    event.Data = lyactive.data;
    //Turn stuff visible
    editctrl.Visible = true;
    event.Visible = true;
    closebtn.Visible = true;
    this.ReFresh();
  }
}

//Save the settings
function ApplySettings(){
  var XMLPath = this.Parameters('TASKPATH');
  var editctrl = this.controls('TaskPath');
  XMLPath.Value = editctrl.Value;
  this.XMLS(0).ForceGetData();
  BuildCalendarForDate(Today.getYear(),Today.getMonth());
  this.ReFresh();
  this.FlipTo(0);
}
//Prompt for new path
function PromptPath(){
  var ctrlPath = this.controls('TaskPath');
  var NewPath =  this.UI.PromptOpenFile('','XML file|*.xml','*.xml','Calendar');
  if (NewPath != '')
    ctrlPath.Value = NewPath;
}
