// main.js

function PlayMM(){
  this.MultiMedia('slide.wav',1);
}

function StopMM(){
  this.MultiMedia('',0);
}

function ToggleFullMode(){
  var IsFullMode = this.parameters.item('FULLMODE').value=='1';
  var IsSmallMode = this.parameters.item('SMALLMODE').value=='1';
  var IsMicroMode = this.parameters.item('MICROMODE').value=='1';
  PlayMM();
  if (IsMicroMode)
    SlideRight();
  if (IsFullMode)
    SlideUp();
  else
    SlideDown();
  StopMM();
  UpdateLayerPos();
}

function ToggleMicroMode(){
  var IsFullMode = this.parameters.item('FULLMODE').value=='1';
  var IsSmallMode = this.parameters.item('SMALLMODE').value=='1';
  var IsMicroMode = this.parameters.item('MICROMODE').value=='1';
  PlayMM();
  if (IsFullMode)
    SlideUp();
  if (IsMicroMode)
    SlideRight();
  else
    SlideLeft();
  StopMM();
  UpdateLayerPos(); 
}

function SlideDown(){ 
  //Inital settings for slide
  var smalllayer = this.layers.item('smallbg');
  var fulllayer = this.layers.item('fullbg');
  this.LockAllUpdates();
  fulllayer.lockupdates();
  fulllayer.visible = true;
  fulllayer.y = smalllayer.y+52
  fulllayer.height = 33;
  fulllayer.ClipSource = '0,153,291,186';
  fulllayer.redraw();
  smalllayer.ClipSource = '';
  smalllayer.height = 52;
  smalllayer.redraw();
  var scoord = '0,153,291,186'
  var ecoord = '0,53,291,186';
  var icoord = '0,-10,0,0'
  this.refresh();
  //Slide
  fulllayer.Slide(scoord,ecoord,icoord,10);
  this.LockAllUpdates();
  fulllayer.lockupdates();
  fulllayer.y = smalllayer.y;
  fulllayer.height = 186;
  //set final layer size
  fulllayer.ClipSource = '0,0,291,186';
  fulllayer.redraw();
  smalllayer.visible = false;
  this.refresh();
  this.parameters.item('FULLMODE').value = '1';
  this.parameters.item('SMALLMODE').value = '0';
}


function SlideUp(){ 
  //Inital settings for slide
  var smalllayer = this.layers.item('smallbg');
  var fulllayer = this.layers.item('fullbg');
  this.LockAllUpdates();
  smalllayer.lockupdates();
  smalllayer.visible = true;
  smalllayer.height = 52;
  smalllayer.ClipSource = '';
  smalllayer.redraw();
  fulllayer.lockupdates();
  fulllayer.y = smalllayer.y + 52;
  fulllayer.height = 133 ;
  fulllayer.ClipSource = '0,53,291,186';
  fulllayer.redraw();
  var scoord = '0,53,291,186'
  var ecoord = '0,153,291,186';
  var icoord = '0,10,0,0'
  this.refresh();
  //Slide
  fulllayer.Slide(scoord,ecoord,icoord,10);
  this.LockAllUpdates();
  //set final layer size
  smalllayer.height = 82;
  fulllayer.visible = false;
  this.refresh();
  this.parameters.item('FULLMODE').value = '0';
  this.parameters.item('SMALLMODE').value = '1';
}

function SlideLeft(){ 
  //Inital settings for slide
  var smalllayer = this.layers.item('smallbg');
  var microlayer = this.layers.item('microbg');
  var cctmp = this.layers.item('cctmp');
  this.LockAllUpdates();
  microlayer.lockupdates();
  microlayer.visible = true;
  microlayer.width = 120;
  microlayer.redraw();
  smalllayer.lockupdates();
  smalllayer.ClipSource = '120,0,290,82';
  smalllayer.x = microlayer.x+120;
  smalllayer.width = 170;
  smalllayer.redraw();
  var scoord = '120,0,290,82'
  var ecoord = '217,0,290,82';
  var icoord = '10,0,0,0'
  //Slide
  this.refresh();
  smalllayer.Slide(scoord,ecoord,icoord,10);
  this.LockAllUpdates();
  //set final layer size
  microlayer.width = 193;
  smalllayer.visible = false;
  cctmp.visible = true;
  this.refresh();
  this.parameters.item('MICROMODE').value = '1';
  this.parameters.item('SMALLMODE').value = '0';
}

function SlideRight(){ 
  //Inital settings for slide
  var smalllayer = this.layers.item('smallbg');
  var microlayer = this.layers.item('microbg');
  var cctmp = this.layers.item('cctmp');
  this.LockAllUpdates();
  cctmp.visible = false;
  smalllayer.lockupdates();
  smalllayer.x = microlayer.x+120;
  smalllayer.width = 73;
  smalllayer.ClipSource = '217,0,290,82';
  smalllayer.visible = true;
  smalllayer.redraw();
  microlayer.width = 120;
  var scoord = '217,0,290,82';
  var ecoord = '120,0,290,82'
  var icoord = '-10,0,0,0'
  //Slide
  this.refresh();
  smalllayer.Slide(scoord,ecoord,icoord,10);
  this.LockAllUpdates();
  smalllayer.lockupdates();
  smalllayer.x = microlayer.x;
  smalllayer.width = 290;
  smalllayer.Clipsource = '0,0,290,82';
  smalllayer.redraw();
  microlayer.visible=false;  
  this.refresh();
  this.parameters.item('MICROMODE').value = '0';
  this.parameters.item('SMALLMODE').value = '1';
}



function updateunit(){
  var unitsel = this.controls.item('unitsel');
  var newunit = unitsel.GetSelectValue(unitsel.newindex);
  if (newunit !=  '')
  {
    this.parameters.item('UNIT').value = newunit;
    this.ForceXDataFetch();
  }
}

function querynewlocation(){
  var citysel = this.controls.item('citysel');
  var OldCode = this.parameters.item('LOCALCODE').value;
  this.parameters.item('SEARCHCLAUSE').value = citysel.display;
  this.xmls.item('2').reset();
  this.xmls.item('2').ForceGetData();
  var NewCity = this.XMLS.item(2).GetValue('[//loc[1]]');
  var NewCode = this.XMLS.item(2).GetValue('[//loc[1]/@id]');

  if ((NewCity != '') &&  (NewCode != '') && (NewCode != OldCode) )
  {
    this.parameters.item('LOCALCODE').value = NewCode;
    citysel.display = NewCity;
    this.ForceXDataFetch();
  }
}

function beforeflip(){
  if (this.GetcurrentSide() == 1)
    querynewlocation();   
}

function buildlist(){
  var citydp  = this.controls.item('citydpsel');
  var citysel = this.controls.item('citysel');
  var OldCode = this.parameters.item('LOCALCODE').value;
  this.parameters.item('SEARCHCLAUSE').value = citysel.display;
  citysel.display = citysel.display;
  this.xmls.item('2').reset();
  this.xmls.item('2').ForceGetData();
  citydp.ListValues = '';
  citydp.ListValues = this.XMLS.item(2).GetValue('[!FILE:searchresultlist.xsl]','',true);
}

function selectnewcity(){
  var citydp  = this.controls.item('citydpsel');
  var citysel = this.controls.item('citysel');
  var OldCode = this.parameters.item('LOCALCODE').value;
  var NewCode = citydp.GetSelectValue(citydp.newindex);
  var NewCity = citydp.GetSelDisplayValue(citydp.newindex);
  if ((NewCity != '') &&  (NewCode != '') && (NewCode != OldCode) )
  {
    this.parameters.item('LOCALCODE').value = NewCode;
    citysel.display = NewCity;
    this.ForceXDataFetch();
  }



}

function GetTodayDate(){
   var d, s = '';           
   d = new Date();                           
   s += (d.getMonth() + 1) + '/';            
   s += d.getDate() + '/';
   s += d.getYear();                         
   return(s);                  
}

function SetSun(){
  var sun = this.parameters.item('SUN').value;
  var newsun = sun;
  var XML = this.XMLS.item('1');
  var timeR = XML.GetValue('[//loc/sunr]');
  var timeS = XML.GetValue('[//loc/suns]');
  var xmltime = new Date(GetTodayDate()+'  '+XML.GetValue('[//loc/tm]'));
  var xmlfiletime =  new Date(XML.GetAgeOfXML());
  var hourdiff = (xmlfiletime.getHours() - xmltime.getHours());
  var mindiff = (xmlfiletime.getMinutes() - xmltime.getMinutes());
  var now = new Date();
  var sunr =new Date(GetTodayDate()+'  '+timeR)
  var suns =new Date(GetTodayDate()+'  '+timeS)
  sunr.setMinutes(sunr.getMinutes()-(hourdiff*60)-mindiff);
  suns.setMinutes(suns.getMinutes()-(hourdiff*60)-mindiff);
  //Set the dates to the same day!!!!
  sunr.setDate(now.getDate());
  sunr.setMonth(now.getMonth());
  sunr.setYear(now.getYear());
  suns.setDate(now.getDate());
  suns.setMonth(now.getMonth());
  suns.setYear(now.getYear());
  //sun set always occurs later than sun rise.
  if (suns < sunr) 
    suns.setDate(now.getDate()+1);
  
  var srtimer = this.timers.item('sunrise');
  //Set the delay in seconds
  srtimer.Delay = (sunr.getHours()*3600) + (sunr.getMinutes()*60) + (sunr.getSeconds());
  srtimer.ResetTimer();
  var sstimer = this.timers.item('sunset');
  //Set the delay in seconds
  srtimer.Delay = (suns.getHours()*3600) + (suns.getMinutes()*60) + (suns.getSeconds());
  sstimer.ResetTimer();
  if ((timeR != '') && (timeS != ''))  
  {
	  if ((sunr <= now) && (suns >= now))
	  {
	    newsun = "AM";
	  }
	  else 
	  {
	    newsun = "PM";
        }
	  if (newsun != sun)
	  {
            this.parameters.item('SUN').value = newsun;
	    this.redraw(); 
	  }
  }
}



function UpdateLayerPos()
{
  var IsFullMode = this.parameters.item('FULLMODE').value=='1';
  var IsSmallMode = this.parameters.item('SMALLMODE').value=='1';
  var IsMicroMode = this.parameters.item('MICROMODE').value=='1';
  var FlipButton = this.layers.item('FrontFlip');
  var ToggleFullBtn = this.layers.item('togglefull');
  var ToggleMicroBtn = this.layers.item('togglemicro');

  FlipButton.LockUpdates();
  ToggleMicroBtn.LockUpdates();
  ToggleFullBtn.LockUpdates();
  if (IsFullMode) 
  {
    FlipButton.X = 297
    FlipButton.Y = 200;
    ToggleFullBtn.Y = 197;
    ToggleFullBtn.Width = 230;
    ToggleMicroBtn.X = 295;
   
  }
  if (IsSmallMode) 
  {
    FlipButton.X = 297
    FlipButton.Y = 98;
    ToggleFullBtn.Y = 95;
    ToggleFullBtn.Width = 230;
    ToggleMicroBtn.X = 295;
  }
  if (IsMicroMode) 
  {
    FlipButton.X = 200
    FlipButton.Y = 98;
    ToggleFullBtn.Y = 95;
    ToggleFullBtn.Width = 133;
    ToggleMicroBtn.X = 198;
  }

  //Redraw all the new layer positions
  FlipButton.ReDraw(); 
  ToggleFullBtn.ReDraw();
  ToggleMicroBtn.ReDraw();
}

function CreateSetup()
{
  UpdateLayerPos();
  SetSun();
}
